LAB-DAE/labApp/labApp/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('votos/', include('votos.urls')),
    path('admin/', admin.site.urls),
]

LAB-DAE/labApp/votos/urls.py
from django.urls import path

from . import views

app_name = 'votos'

urlpatterns = [
    path('', views.index, name='index'),
    path('<int:region_id>/', views.detalle, name='detalle'),
    path('<int:region_id>/resultados/', views.resultados, name='resultados'),
    path('<int:region_id>/voto/', views.votar, name='votar'),
]

LAB-DAE/labApp/votos/models.py
from django.db import models

# Create your models here.

class Region(models.Model):
    region_txt = models.CharField(max_length=200)
    
class Candidato(models.Model):
    region = models.ForeignKey(Region, on_delete=models.CASCADE)
    candidato = models.CharField(max_length=200)
    votos = models.IntegerField(default=0)

LAB-DAE/labApp/votos/views.py
from django.shortcuts import get_object_or_404, render
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse

from .models import Region, Candidato
# Create your views here.

def index(request):
    latest_question_list = Region.objects.order_by('-region_txt')[:5]
    context = {'latest_question_list': latest_question_list}
    return render(request, 'votos/index.html', context)

def detalle(request, region_id):
    region = get_object_or_404(Region, pk=region_id)
    return render(request, 'votos/detalle.html', {'region': region})

def votar(request, region_id):
    region = get_object_or_404(Region, pk=region_id)
    try:
        selected_opcion = region.candidato_set.get(pk=request.POST['candidato'])
    except (KeyError, Candidato.DoesNotExist):
        return render(request, 'votos/detalle.html',{
            'region' : region,
            'error_message': "No has seleccionado un candidato.",
        })
    else:
        selected_opcion.votos += 1
        selected_opcion.save()
        return HttpResponseRedirect(reverse('votos:resultados', args=(region.id,)))

def resultados(request, region_id):
    region = get_object_or_404(Region, pk=region_id)
    return render(request, 'votos/resultados.html', {'region': region})

LAB-DAE/labApp/votos/templates/votos/detalle.html
<h1>{{ region.region_txt }}</h1>

{% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}

<form action="{% url 'votos:votar' region.id %}" method="POST">
{% csrf_token %}
{% for candidato in region.candidato_set.all %}
    <input type="radio" name="candidato" id="candidato{{ forloop.counter }}" value="{{ candidato.id }}">
    <label for="candidato{{ forloop.counter }}">{{ candidato.candidato }}</label><br>
{% endfor %}
<input type="submit" value="Votar">
</form>
<br/>
<a href="{% url 'votos:index' %}">Ver Regiones</a>

LAB-DAE/labApp/votos/templates/votos/index.html
<h1>Aplicación Sufragio 2021</h1>

{% if latest_question_list %}
    <ul>
    {% for region in latest_question_list %}
        <li>
            <a href="/votos/{{ region.id }}/">{{ region.region_txt }}</a>
        </li>
    {% endfor %}
    </ul>
{% else %}
    <p>No hay registros.</p>
{% endif %}

LAB-DAE/labApp/votos/templates/votos/resultados.html
<h1>{{ region.region_txt }}</h1>

<ul>
{% for candidato in region.candidato_set.all %}
    <li>{{ candidato.candidato }} -- {{ candidato.votos }} voto{{ candidato.votos|pluralize }}</li>
{% endfor %}
</ul>

<a href="{% url 'votos:index' %}">Ver Regiones</a>